﻿using System;
using System.Collections.Generic;

namespace 迭代器延迟计算Demo
{
    class Program
    {
        /// <summary>
        ///  演示迭代器延迟计算
        /// </summary>
        /// <param name="args"></param>
        static void Main(string[] args)
        {
            // 测试一
            //WithIterator();
            //Console.Read();

            // 测试二
            //WithNoIterator();
            //Console.Read();

            // 测试三
            foreach (int j in WithIterator())
            {
                Console.WriteLine("在main输出语句中，当前i的值为：{0}", j);
            }

            Console.Read();
        }

        public static IEnumerable<int> WithIterator()
        {
            for (int i = 0; i < 5; i++)
            {
                Console.WriteLine("在WithIterator方法中的, 当前i的值为：{0}", i);
                if (i > 1)
                {
                    yield return i;
                }
            }
        }

        public static IEnumerable<int> WithNoIterator()
       {
           List<int> list = new List<int>();
           for (int i = 0; i < 5; i++)
           {
               Console.WriteLine("当前i的值为：{0}", i);
               if (i > 1)
               {
                   list.Add(i);
               }
           }

           return list;
       }
    }
}
